#!/bin/bash

# YaST Configuration file
CONF="/etc/opt/novell/ncl/tray_app.conf"

# LNK file for KDE autostart
SOURCELNK="/opt/kde3/share/applications/kde/ncl_tray.desktop"
GNOME_CMD="gnome-starter.bsh"
# setting up PATH variable
if [ -z `echo $PATH | grep "/opt/novell/ncl/bin"` ];then
    export PATH="$PATH:/opt/novell/ncl/bin"
fi;


disable_autostart() {

# Remove GNOME autostart
if [ -f "$HOME/.gnome2/session-manual" -a `grep "/opt/novell/ncl/bin/$GNOME_CMD" $HOME/.gnome2/session-manual | wc -l` -gt 0 ]; then
    NUMBER=`cat $HOME/.gnome2/session-manual | grep 'num_clients' | cut -d= -f2`
    ID=`grep "/opt/novell/ncl/bin/$GNOME_CMD" $HOME/.gnome2/session-manual | cut -f1 -d,`

    let NUMBER-=1

    perl -pi -e "s|num_clients=[0-9]+|num_clients=$NUMBER|" $HOME/.gnome2/session-manual
    perl -pi -e "s|^$ID,.*?\n||gsx" $HOME/.gnome2/session-manual
    
fi

# Remove KDE autostart
if [ -f "$HOME/.kde/Autostart/`basename $SOURCELNK`" ]; then
    rm -f "$HOME/.kde/Autostart/`basename $SOURCELNK`"
fi

}

enable_autostart(){

# GNOME autostart
[ -d "$HOME/.gnome2" ] || mkdir $HOME/.gnome2

if [ ! -f "$HOME/.gnome2/session-manual" ]; then

cat >$HOME/.gnome2/session-manual <<END

[Default]
num_clients=1
0,RestartStyleHint=3
0,Priority=50
0,RestartCommand=/opt/novell/ncl/bin/$GNOME_CMD
END

else

    NUMBER=`cat $HOME/.gnome2/session-manual | grep 'num_clients' | cut -d= -f2`

    if [ `cat  $HOME/.gnome2/session-manual | grep "$GNOME_CMD" | wc -l` -eq 0 ]; then
    
cat  >>$HOME/.gnome2/session-manual <<END
$NUMBER,RestartStyleHint=3
$NUMBER,Priority=50
$NUMBER,RestartCommand=/opt/novell/ncl/bin/$GNOME_CMD
END

	let NUMBER+=1

	perl -pi -e "s|num_clients=[0-9]+|num_clients=$NUMBER|" $HOME/.gnome2/session-manual
    fi

fi

# KDE autostart
[ -d "$HOME/.kde" ] || mkdir $HOME/.kde

if [ -d "$HOME/.kde" ]; then
    [ -d "$HOME/.kde/Autostart" ] || mkdir $HOME/.kde/Autostart
    #if [ ! -f "$HOME/.kde/Autostart/`basename $SOURCELNK`" ]; then
	cp -f $SOURCELNK $HOME/.kde/Autostart/
    #fi
fi

}

# insert excludeApps
if [ ! -f "$HOME/.kde/share/config/ksmserverrc" ]; then
    mkdir -p $HOME/.kde/share/config
    touch $HOME/.kde/share/config/ksmserverrc
fi

if [ `grep '\[General\]' $HOME/.kde/share/config/ksmserverrc | wc -l` -eq 0 ]; then
    echo -e "\n[General]" >> $HOME/.kde/share/config/ksmserverrc
    echo "excludeApps=ncl_tray" >> $HOME/.kde/share/config/ksmserverrc
else
    if [ `grep 'excludeApps' $HOME/.kde/share/config/ksmserverrc | wc -l` -eq 0 ]; then
	perl -pi -e "s|\[General\]|\[General\]\nexcludeApps=ncl_tray|" $HOME/.kde/share/config/ksmserverrc
    else
	if [ `grep '^excludeApps=.*ncl_tray' $HOME/.kde/share/config/ksmserverrc | wc -l` -eq 0 ]; then
	    perl -pi -e 's|excludeApps=(.*)|excludeApps=ncl_tray:$1|' $HOME/.kde/share/config/ksmserverrc
	fi
    fi
fi

if [ -f $CONF ]; then
	if [ `grep 'Launch_Tray_App=false' $CONF | wc -l` -gt 0 ]; then
    		disable_autostart
	else
    		enable_autostart
	fi
else
	enable_autostart
fi
